<h1 align="center">OmniRegress </h1>
<p align="center"><b>The fast, modern Python & Rust library for all your regression adventures.</b></p>

OmniRegress: A comprehensive Python & Rust library for all types of regression analysis.

## 🚀 Update: 3.0

✨ **Brand New:**  
- 🦀 **Linear Regression** — Now blazing fast, implemented from scratch in Rust!  
- 🦀 **Polynomial Regression** — Pure Rust power for nonlinear fits!  
- 🦀 **Logistic Regression** — Native Rust implementation for robust binary classification!

### 🔵 **Basic Regression Models**  
- [✅] **Linear Regression** — Fast, pure Rust core. ([Usage 🚀](docs/Usage/LinearRegression.md))
- [✅] **Polynomial Regression** — Nonlinear fits, Rust-powered. ([Usage 🚀](docs/Usage/PolynomialRegression.md))
- [✅] **Logistic Regression** — Native Rust, robust binary classification. ([Usage 🚀](docs/Usage/LogisticRegression.md))
- [🚧] **Ridge Regression (L2)** — 🛡️ Regularization to prevent overfitting.
- [🚧] **Lasso Regression (L1)** — ✂️ Feature selection with L1 penalty.
- [ ] **Elastic Net** — 🧬 Hybrid L1 + L2 regularization.

---

### 🟢 **Specialized Regression**  
- [ ] **Poisson Regression** — 📈 For count data (e.g., website visits).
- [ ] **Cox Regression** — ⏳ Survival/time-to-event analysis.
- [ ] **Quantile Regression** — 🎯 Predicts specific percentiles (e.g., median).
- [ ] **Bayesian Regression** — 🎲 Incorporates prior distributions.

---

### 🟠 **Nonlinear & ML-Based**  
- [ ] **Support Vector Regression (SVR)** — 🌀 Kernel magic for complex patterns.
- [ ] **Decision Tree Regression** — 🌳 Hierarchical, rule-based splits.
- [ ] **Random Forest Regression** — 🌲🌲 Ensemble of decision trees.
- [ ] **Neural Network Regression** — 🧠 Deep learning for high-dimensional data.

---

### 🟣 **Other Advanced Types**  
- [ ] **Gaussian Process Regression** — 🔮 Probabilistic nonlinear modeling.
- [ ] **Negative Binomial Regression** — 🧮 Overdispersed count data.
- [ ] **Multinomial Logistic Regression** — 🏷️ Multi-class classification.
